summaryrefslogtreecommitdiff
path: root/tests/misc/stat-nanoseconds.sh
diff options
context:
space:
mode:
authorStefano Lattarini <stefano.lattarini@gmail.com>2012-08-30 14:13:12 +0200
committerJim Meyering <meyering@redhat.com>2012-08-30 18:55:59 +0200
commit9eb4c31eb78c28dd9f72d1cbb940270311be343c (patch)
treeea3078bc1b002a9f948ed41445ca32318002a1d3 /tests/misc/stat-nanoseconds.sh
parent00f5ba15dd91a3d9780fe1fbd06a4df436ae6714 (diff)
downloadcoreutils-9eb4c31eb78c28dd9f72d1cbb940270311be343c.tar.xz
tests: add .sh and .pl suffixes to shell and perl tests, respectively
Not only this shrinks the size of the generated Makefile (from > 6300 lines to ~3000), but will allow further simplifications in future changes. * tests/Makefile.am (TEST_EXTENSIONS): Add '.sh' and '.pl'. (PL_LOG_COMPILER, SH_LOG_COMPILER): New, still defined simply to $(LOG_COMPILER) for the time being. (TESTS, root_tests): Adjust as described. * All tests: Rename as described.
Diffstat (limited to 'tests/misc/stat-nanoseconds.sh')
-rwxr-xr-xtests/misc/stat-nanoseconds.sh46
1 files changed, 46 insertions, 0 deletions
diff --git a/tests/misc/stat-nanoseconds.sh b/tests/misc/stat-nanoseconds.sh
new file mode 100755
index 000000000..1afb610f9
--- /dev/null
+++ b/tests/misc/stat-nanoseconds.sh
@@ -0,0 +1,46 @@
+#!/bin/sh
+# Exercise format strings involving %:X, %:Y, etc.
+
+# Copyright (C) 2010-2012 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+print_ver_ stat
+. "${srcdir=.}/init.sh"; path_prepend_ ../src
+
+# Set this to avoid problems with weird time zones.
+TZ=UTC0
+export TZ
+
+# Use a time stamp near the Epoch to avoid trouble with leap seconds.
+touch -d '1970-01-01 18:43:33.023456789' k || framework_failure_
+
+ls --full-time | grep 18:43:33.023456789 \
+ || skip_ this file system does not support sub-second time stamps
+
+test "$(stat -c %X k)" = 67413 || fail=1
+test "$(stat -c %.X k)" = 67413.023456789 || fail=1
+test "$(stat -c %.1X k)" = 67413.0 || fail=1
+test "$(stat -c %.3X k)" = 67413.023 || fail=1
+test "$(stat -c %.6X k)" = 67413.023456 || fail=1
+test "$(stat -c %.9X k)" = 67413.023456789 || fail=1
+test "$(stat -c %13.6X k)" = ' 67413.023456' || fail=1
+test "$(stat -c %013.6X k)" = 067413.023456 || fail=1
+test "$(stat -c %-13.6X k)" = '67413.023456 ' || fail=1
+test "$(stat -c %18.10X k)" = ' 67413.0234567890' || fail=1
+test "$(stat -c %I18.10X k)" = ' 67413.0234567890' || fail=1
+test "$(stat -c %018.10X k)" = 0067413.0234567890 || fail=1
+test "$(stat -c %-18.10X k)" = '67413.0234567890 ' || fail=1
+
+Exit $fail